var matchTitles = new Array();
var descriptions = new Array();
var link = new Array();
var defaultMatch = 0;
var state = 1;
var rss;
var numWickets = 0;
var alertBool = true;
var timeInterval = 5000;
var prefs;

// Default source to retrive the matches information
var source = "http://cricinfo.com/rss/livescores.xml";

/*
 * Toggle the state(Enable/Disable) of the scoreboard.
 * */
function toggleState() {
	var scoreboardEnabled = document.getElementById("scoreboardState");
	if(scoreboardEnabled.getAttribute("label") == "Start ScoreWatch") {
            scoreboardEnabled.setAttribute("label", "Pause ScoreWatch");
   //         prefs.setBoolPref("enable", true);
            state = 1;
            document.getElementById("scoreText").setAttribute("value", "Updating Scores");
            getScore();
        } else {
            //            prefs.setBoolPref("enable", false);
            scoreboardEnabled.setAttribute("label", "Start ScoreWatch");
            state = 0;
            stopUpdating();
        }
}


/*
 * Function to change the source.
 * This function is called when the user tries to change the source
 * */
function setSource(url) { 
    hideAlert();
    var selectedSrcIndex = document.getElementById("selectSource").selectedIndex;
    if(prefs.getIntPref("srcIndex") != selectedSrcIndex) {
        var panel = document.getElementById("scoreText");

        var matchList = document.getElementById("presentMatches");
        while (matchList.firstChild) {
            matchList.removeChild(matchList.firstChild);
        }

        panel.setAttribute("value", "Updating Scores");
        prefs.setCharPref("source", url);
        prefs.setIntPref("srcIndex", document.getElementById("selectSource").selectedIndex);
        source = url;
        getScore();
        numWickets = 0;
    }
}

function loadSettings() {
    prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
        prefs = prefs.getBranch("extensions.ScoreWatch.");

    timeInterval = prefs.getIntPref("timeInterval");
    alertBool = prefs.getBoolPref("allowAlerts");
    appEnabled = prefs.getBoolPref("enable");
    source = prefs.getCharPref("source");

    document.getElementById("selectSource").selectedIndex = prefs.getIntPref("srcIndex");
    if(!appEnabled) {
        document.getElementById("scoreboardState").setAttribute("label",
                "Start ScoreWatch");
        state = 0;
    } else {
        document.getElementById("scoreboardState").setAttribute("label",
                "Pause ScoreWatch");
        state = 1;
        document.getElementById("scoreText").setAttribute("value", "Updating Scores");
    }
    getScore();
}

function changeMatch(matchNum) {
    hideAlert();
    numWickets = 0;
    document.getElementById("scoreboardProps").hidePopup();
    defaultMatch = matchNum;
    var panel = document.getElementById("scoreText");
    panel.setAttribute("value", descriptions[matchNum][0].firstChild.nodeValue);
}

function getHTTPObject() { 
    return new XMLHttpRequest(); 
}

function parseRSS() {
    var panel = document.getElementById("scoreText");

    var xmlobject = (new DOMParser()).parseFromString(rss, "text/xml");

    if(rss.indexOf(document.getElementById("selectSource").selectedItem.label) == -1 ) {
        return;
    }

//    var root = xmlobject.getElementsByTagName('rss')[0];
    if(!(root = xmlobject.getElementsByTagName('rss')[0])) {
        panel.setAttribute("value", "Server Error: Try another Source");
        return;
    }

    var channels = root.getElementsByTagName("channel");
    var items = channels[0].getElementsByTagName("item");

    var matchList = document.getElementById("presentMatches");
    while (matchList.firstChild) {
        matchList.removeChild(matchList.firstChild);
    }

    if(items.length == 0) {
        item = document.createElement("label");
        item.setAttribute("value", "No Matches");
        matchList.appendChild(item);
    }

    menuRows = document.createElement("vbox");
    for(var i = 0; i < items.length; i++) {
        matchTitles[i] = items[i].getElementsByTagName("title");
        descriptions[i] = items[i].getElementsByTagName("description");
        link[i] = items[i].getElementsByTagName("link");


        menuCol = document.createElement("hbox");
        item = document.createElement("menuitem");
        item.setAttribute("label", matchTitles[i][0].firstChild.nodeValue);
        item.setAttribute("oncommand", "changeMatch(" + i + ")");
        item.setAttribute("flex", "1");

        if( i == defaultMatch) {
            panel.setAttribute("value", descriptions[i][0].firstChild.nodeValue);
            if(alertBool) {
                showAlert(descriptions[i][0].firstChild.nodeValue);
            }
        }

        menuCol.appendChild(item);

        item = document.createElement("button");
        item.setAttribute("label", "Full Scorecard");
        item.setAttribute("oncommand", "showScoreCard(" + i + ")");
        menuCol.appendChild(item);

        menuRows.appendChild(menuCol);

    }
    matchList.appendChild(menuRows);

    if( defaultMatch >= items.length) {
        panel.setAttribute("label", descriptions[0][0].firstChild.nodeValue);
        if(alertBool) {
            showAlert(descriptions[0][0].firstChild.nodeValue);
        }
    } 
}

function showAlert(desc) {
    if(source.indexOf("cricinfo") != -1) {
        pos = desc.indexOf("*");
        if(desc[pos-3] == "/") {
            wicketsNow = desc[pos - 2];
        } else {
            if(desc[pos-4] == "/") {
                wicketsNow = 10;
            }
        }
    } else if(source.indexOf("ecb") != -1) {
        pos = desc.indexOf("-");
        if(desc[pos + 3] == " ") {
            wicketsNow = 10;
        } else {
            wicketsNow = desc[pos + 1];
        }
    }

    if(pos != -1) {
        var wicksStr = "wickets down";
        if(wicketsNow == 1) {
            wicksStr = "wicket down";
        }
        if(wicketsNow > numWickets) {
            document.getElementById("numWicketsPop").setAttribute("value",
                    wicketsNow + wicksStr);
            document.getElementById("wicketAlert").showPopup(document.getElementById("score-panel"), -1, -1, "tooltip", "topleft", "bottomleft");
            setTimeout("hideAlert()", 3500);
        }
        numWickets = wicketsNow;
    } else {
        numWickets = 0;
    }

}

function hideAlert() {
    document.getElementById("wicketAlert").hidePopup();
    document.getElementById("scoreboardProps").hidePopup();
}

function showScoreCard(matchNum) {
    document.getElementById("scoreboardProps").hidePopup();
    window.delayedOpenTab(link[matchNum][0].firstChild.nodeValue);
}


function startTimer() {
    setTimeout('getScore()',timeInterval);
    if(state != 1) {
        stopUpdating();
    }
}

function startPrefsTimer() {
    setTimeout('updatePrefs()',timeInterval);
}

function stopUpdating() {
    panel = document.getElementById("scoreText");
    panel.setAttribute("value", "ScoreWatch");
    var matchList = document.getElementById("presentMatches");
    while (matchList.firstChild) {
        matchList.removeChild(matchList.firstChild);
    }
    item = document.createElement("label");
    item.setAttribute("value", "No Matches");
    matchList.appendChild(item);
}

function updatePrefs() {
    timeInterval = prefs.getIntPref("timeInterval");
    alertBool = prefs.getBoolPref("allowAlerts");
}

function getScore() {
    updatePrefs();
    if(state == 1) {
        var http = getHTTPObject(); 
        http.onreadystatechange = function() { 
            if (http.readyState == 4) { 
                rss = http.responseText;
                if(state == 1) {
                    parseRSS(); 
                }
            } 
        } 
        http.open("GET", source, true); 
        http.send(null);
    } else {
        stopUpdating();
    }
    startTimer();
}

function changeMenuElements() {
    document.getElementById("selectSource").selectedIndex = prefs.getIntPref("srcIndex");
    if(state == 0) {
        document.getElementById("matcheslist").collapsed = true;
        document.getElementById("sourceRow").collapsed = true;
        document.getElementById("prefsSrcSeperator").collapsed = true;
    } else {
        document.getElementById("matcheslist").collapsed = false;
        document.getElementById("sourceRow").collapsed = false;
        document.getElementById("prefsSrcSeperator").collapsed = false;
    }
}
